#pragma once
#include <utility>
#include <set>
#include "consts.h"


struct Candidate {
	std::pair<int, int> candidate_pair;
	bool	is_one; // true one_pairs, false other_pairs

	Candidate(int i, int j, bool _is_one = false);
	Candidate(const std::pair<int, int> &_candidate_pair, bool _is_one); 
	bool operator<(const Candidate &cand2) const; 
};

// searches candidates for a pair (a,b) a<=b, resp. (b,a) b < a
bool is_summable_candidate(const std::set<Candidate> &candidates, int a, int b); 

bool check_summability(const std::set<Candidate> &candidates, const std::pair<int, int> &test_pair, const std::set<int> *(&op)[MAX][MAX]); 
