#include <iostream>
#include <iomanip>
#include <string.h>
#include <stdlib.h>
#include <fstream>
#include <vector>

#include "hyperEA3_common.h"
//#include "hea.h"
#include "hyperEA3_parse.h"
	

using namespace std;




int main(int argc, char **argv) {

	if (argc < 2) {
		cout << "Usage: " << argv[0] << " filename " << endl;
		return 0;
	
	}

	const int n = 7;

	set<int> setCandidates[1 << MAX];
	const set<int>* op[MAX][MAX];

	// init
	for (int i = 0; i < 1 << n; i++) {
		setCandidates[i] = set<int>();
		hea::init_set_i(setCandidates[i], i);
	}
	

	int complement[MAX];
	int idx = 1;
	while (idx < argc) {
		ifstream ifs;

		ifs.open(argv[idx], ifstream::in);
		
		if (ifs.good()) {
			cerr << "Loading file " << argv[idx] << "." << endl;


			while(hea::parse_model(ifs, n, op, complement, setCandidates)) {

				// dumps  state
				for (int i = 0; i < n; i++)
					for (int j = i; j < n; j++)
						if (op[i][j] != &setCandidates[0])
							cout << (op[i][j] - &setCandidates[0]) << ", ";
				cout << endl;


				// skip one line containing -M-
				char buffer[1024];
				ifs.getline(buffer, 1024);
			}
				
		}
		else {
			cerr << "Cannot open or read from file '" << argv[idx] << "'." << endl;
		}
		ifs.close();

		idx++;
	}
	
	return 0;
}
