#pragma once

#include <iostream>
#include <set>
#include "consts.h"
#include <vector>
#include "permutation.h"

namespace hea {

struct Hea {
	int n;
	const std::set<int> *op[MAX][MAX];
	int complement[MAX];

	Hea(const int _n, const std::set<int> * const _op[MAX][MAX], const int (&_complement)[MAX]); 	
};

void disp_hea(std::ostream &os, const Hea &hea); 

void are_isomorphic_via_perm(int level, const Hea &hea1, const Hea &hea2, const std::set<int> *setCandidates, int (&permutation)[MAX], bool &is_iso); 
bool are_isomorphic(const Hea &hea1, const Hea &hea2, const std::set<int> *setCandidates); 

void generate_all_order_preserving_permutations_recursive(int level, const Hea &hea, int (&permutation)[MAX], const bool include_identity_permutation, std::vector<Permutation> &vec_order_preserve); 
void generate_all_order_preserving_permutations(const Hea &hea, const bool include_identity_permutation, std::vector<Permutation> &vec_order_preserve); 

bool are_isomorphic_via_perm(const Hea &hea1, const Hea &hea2, const std::set<int> *setCandidates, const int (&permutation)[MAX]); 
bool are_isomorphic_perm_list(const Hea &hea1, const Hea &hea2, const std::set<int> *setCandidates, const std::vector<Permutation> &vec_perm); 
void select_plan_preserving_permutations_old(const Hea &hea, std::vector<Permutation> &vec_order_preserve); 
void select_plan_preserving_permutations(const Hea &hea, const std::vector<Permutation> &vec_order_preserve, std::vector<Permutation> &out_vector);



} // end namespace hea
