#pragma once

#include <iostream>
#include <set>
#include <vector>

#include "consts.h"

namespace hea {

bool is_summable(const std::set<int>* const (&op)[MAX][MAX], const int a, const int b);
bool is_summable(const std::set<int>* const (&op)[MAX][MAX], const int a, const std::set<int> &set_b);
bool is_summable(const std::set<int>* const (&op)[MAX][MAX], const std::set<int> &set_a, 
				const std::set<int> &set_b);

std::set<int> compute_sum(const std::set<int>* const (&op)[MAX][MAX], const int a, const int b); 
std::set<int> compute_sum(const std::set<int>* const (&op)[MAX][MAX], const int a, 
				const std::set<int> &set_b); 
std::set<int> compute_sum(const std::set<int>* const (&op)[MAX][MAX], const std::set<int> &set_a, 
				const std::set<int> &set_b);

void disp_elem(std::ostream &os, const int n, int elem);

void disp_set(std::ostream &os, const int n, const std::set<int> &ds);

void disp_complement(std::ostream &os, const int n, const int (&op)[MAX]);
void disp_op(std::ostream &os, const int n, const std::set<int>* const (&op)[MAX][MAX]);

int is_associative(const int n, const std::set<int> * const (&op)[MAX][MAX]);

bool is_antisymmetric(const int n, const std::set<int>* const (&op)[MAX][MAX], const int (&complement)[MAX]);

bool is_transitive(const int n, const std::set<int>* const (&op)[MAX][MAX], const int (&complement)[MAX]);

bool test_subsets_new(const int n, int candidate, const std::set<int> * const (&op)[MAX][MAX], int y, const std::set<int> *setCandidates); 

void init_set_i(std::set<int> &set, int i); 

void iso_image(const int n, const std::set<int> * const (&op)[MAX][MAX], const int (&perm)[MAX], const std::set<int> *setCandidates, const std::set<int>* (&op2)[MAX][MAX]); 
void iso_image_full(const int n, const std::set<int> * const (&op)[MAX][MAX], const int (&complement)[MAX], const int (&perm)[MAX], const std::set<int> *setCandidates, const std::set<int>* (&op2)[MAX][MAX], int (&complement2)[MAX]); 

bool are_equal_op(const int n, const std::set<int>* const (&op)[MAX][MAX], const std::set<int>* const (&op2)[MAX][MAX]); 

void dump_state(std::ostream &os, int n, const std::set<int>* const (&op)[MAX][MAX], const std::set<int> *setCandidates);

void dump_state_to_vector(int n, const std::set<int>* const (&op)[MAX][MAX], const std::set<int> *setCandidates, std::vector<int> &state_vector) ;

int compare_states(const std::vector<int> &state1, const std::vector<int> &state2); 

bool testCandidateSetForXPlusXContainingOne(int i, int x, const int n, const std::set<int> *(&op)[MAX][MAX], std::set<int> *setCandidates); 
bool testCandidateSetForXPlusYJustOneContainingOne(int i, int x, bool only0x, int y, const int n, const std::set<int> *(&op)[MAX][MAX], std::set<int> *setCandidates); 
bool testCandidateSetForXPlusYBothContainingOne(int i, int x, int y, const int n, const std::set<int> *(&op)[MAX][MAX], std::set<int> *setCandidates); 

}
