#include <iomanip>
#include <string.h>
#include <stdlib.h>
#include <fstream>
#include <vector>

#include "hyperEA3_common.h"
#include "hea.h"
#include "hyperEA3_parse.h"
#include "permutation.h"
	

using namespace std;

#if 0
void generate_all_order_preserving_permutations_recursive(int level, const hea::Hea &hea, int (&permutation)[MAX], vector<hea::Permutation> &vec_order_preserve) {

	if (level == hea.n - 2) {
		
#ifdef DISTINCT
		bool is_identity = true;
		for (int i = 1 ; i < hea.n - 1; i++)
			if (i != permutation[i]) {
				is_identity = false;
				break;
			}
				

		if (!is_identity) {
#endif
			for (int i = 1; i < hea.n - 1; i++)
			for (int j = 1; j < hea.n - 1; j++) {
				if (hea::is_summable(hea.op, i, hea.complement[j]) && !hea::is_summable(hea.op, permutation[i], hea.complement[permutation[j]]))
					return ;
				if (hea::is_summable(hea.op, permutation[i], hea.complement[permutation[j]]) && !hea::is_summable(hea.op, i, hea.complement[j]))
					return ;
			}

			vec_order_preserve.push_back(hea::Permutation(hea.n, permutation));
#ifdef DISTINCT
		}
#endif


	}
	else {
		for (int i = level; i < hea.n - 1; i++) {
			//swap level i
			if (i != level) {
				int tmp = permutation[level];
				permutation[level] = permutation[i];
				permutation[i] = tmp;
			}
			generate_all_order_preserving_permutations_recursive( level + 1, hea, permutation, vec_order_preserve);
			//swap level i
			if (i != level) {
				int tmp = permutation[level];
				permutation[level] = permutation[i];
				permutation[i] = tmp;
			}
		}
		
	}

}

void generate_all_order_preserving_permutations(const hea::Hea &hea, vector<hea::Permutation> &vec_order_preserve) {
	int permutation[MAX];
	for (int i = 0; i < hea.n; i++)
		permutation[i] = i;

	generate_all_order_preserving_permutations_recursive(1, hea, permutation, vec_order_preserve);
}
#endif

#if 0
void are_isomorphic_via_perm(int level, const hea::Hea &hea1, const hea::Hea &hea2, const set<int> *setCandidates, int (&permutation)[MAX], bool &is_iso) {
	if (!is_iso) {
		if (level == hea1.n - 2) {
			/*
			for (int i = 0; i < hea1.n; i++)
				cout << permutation[i] << " ";
			cout << endl;
			*/

			const set<int> *op_iso[MAX][MAX];
			iso_image(hea1.n, hea1.op, permutation, setCandidates, op_iso);

			if (are_equal_op(hea2.n, hea2.op, op_iso)) {
				is_iso = true;
				/* write information to cerr */

				cerr << "Eliminating ... " << endl;
				disp_hea(cerr, hea2);
				cerr << "\tby" << endl;
				disp_hea(cerr, hea1);
				cerr << "Isomorphism: ";
				for (int i = 0; i < hea1.n; i++) {
					hea::disp_elem(cerr, hea1.n, permutation[i]);
					cerr << " ";
				}
				cerr << endl << "\t---" << endl;
			}	
		}
		else {
			for (int i = level; i < hea1.n - 1; i++) {
				//swap level i
				if (i != level) {
					int tmp = permutation[level];
					permutation[level] = permutation[i];
					permutation[i] = tmp;
				}
				are_isomorphic_via_perm( level + 1, hea1, hea2, setCandidates, permutation, is_iso);
				//swap level i
				if (i != level) {
					int tmp = permutation[level];
					permutation[level] = permutation[i];
					permutation[i] = tmp;
				}
			}
			
		}
	}
}




bool are_isomorphic(const hea::Hea &hea1, const hea::Hea &hea2, const set<int> *setCandidates) {
	if (hea1.n != hea2.n)
		return false;

	int permutation[MAX];
	for (int i = 0; i < hea1.n;i++)
		permutation[i] = i;

	bool is_iso = false;

	are_isomorphic_via_perm(1, hea1, hea2, setCandidates, permutation, is_iso);

	return is_iso;
}
#endif






void disp_hea(const hea::Hea &hea) {
	/* display complement */
	for (int i =0 ; i < hea.n; i++) {
		hea::disp_elem(cout, hea.n, i);
		cout << "  ";
	}
	cout << endl;

	for (int i =0 ; i < hea.n; i++) {
		hea::disp_elem(cout, hea.n, hea.complement[i]);
		cout << "  ";
	}
	cout << endl;

	hea::disp_op(cout, hea.n, hea.op);
	cout << "\t-M-" << endl;
}


int main(int argc, char **argv) {


#if 0
	int complement[MAX];
	ifstream ifs;

	ifs.open("model.txt", ifstream::in);
	
	if (ifs.good()) {
		if (parse_complement(ifs, 6, complement)) {

			cout << endl << "HERE" << endl;

			for (int i = 0; i < 6; i++)
				cout << complement[i] << " ";

			cout << endl;

		}
			
	}
	ifs.close();

	return 0;


	const int n = 6;
	string test_set1="{0,1}";
	string test_set2="{0,a,b,c,d}";
	int set_val;
	const char *pom = test_set1.c_str();
	int line_nums[MAX];

	if (parse_set(&pom, n, set_val))
		cout << set_val << endl;
	else
		cout << "Err 1" << endl;

	pom = test_set2.c_str();
	if (parse_set(&pom, n, set_val))
		cout << set_val << endl;
	else
		cout << "Err 2" << endl;

	pom = test_set2.c_str();
	if (parse_line(&pom, n, line_nums))
		cout << "OK" << endl;
	else
		cout << "ERR" << endl;

	string line1 = "{d}, {1}, {}, {0, a, b, c, d}, {0, a, b, c, d}, {},";
	string line2 = "{c}, {}, {0, 1}, {0, a, b, c, d}, {0, a, b, c, d}, {},";
	string line3 = "{c}, {}, {0, 1}, {0, a, b, c, d}, {0, a, b, c, d}, {},   ";
	cout << "Line 1: " << endl;
	pom = line1.c_str();
	if (parse_line(&pom, n, line_nums))
		cout << "OK" << endl;
	else
		cout << "ERR" << endl;
	cout << "Line 2: " << endl;
	pom = line2.c_str();
	if (parse_line(&pom, n, line_nums))
		cout << "OK" << endl;
	else
		cout << "ERR" << endl;
	cout << "Line 3: " << endl;
	pom = line3.c_str();
	if (parse_line(&pom, n, line_nums))
		cout << "OK" << endl;
	else
		cout << "ERR" << endl;


	




	return 0;
#endif

	if (argc < 2) {
		cout << "Usage: " << argv[0] << " filename [filename2 ...]" << endl;
		cout << "It is assumed, that all models have the same relation '<='." << endl;
#ifdef DISTINCT
		cout << "It is assumed, that all models are mutually different." << endl;
#endif

		return 0;
	
	}

	vector<hea::Hea> non_iso_list;
	bool is_first = true;

	const int n = 6;

	set<int> setCandidates[1 << MAX];
	const set<int>* op[MAX][MAX];

	// init
	for (int i = 0; i < 1 << n; i++) {
		setCandidates[i] = set<int>();
		hea::init_set_i(setCandidates[i], i);
	}
	
	int complement[MAX];
	int idx = 1;

	vector<hea::Permutation> permutation_candidates;

	while (idx < argc) {
		ifstream ifs;

		ifs.open(argv[idx], ifstream::in);
		
		if (ifs.good()) {
			cerr << "Loading file " << argv[idx] << "." << endl;

	/*
			// skip header and copy header
			
			int to_skip = 2;
			char buffer[1024];
			while (to_skip > 0) {
				ifs.getline(buffer, 1024);
				if (!strncmp(buffer, "-----", 5)) {
					//cout << "Skipped..." <<endl;
					to_skip--;
				}
				cout << buffer<<endl;
			}

	*/

			while(hea::parse_model(ifs, n, op, complement, setCandidates)) {

				/*
				cout << "Testing ..." << endl;
				for (int i = 0; i < n; i++) {
					disp_elem(n, complement[i]);
					cout << " ";
				}
				cout << endl;
				disp_op(n, op);
				*/

				hea::Hea tested_hea(n, op, complement);

				if (is_first) {
					is_first = false;
					disp_hea(tested_hea);
					non_iso_list.push_back(tested_hea);
#ifdef DISTINCT
// include_identity_permutation = false
					generate_all_order_preserving_permutations(tested_hea, false, permutation_candidates);
#else
// include_identity_permutation = true
					generate_all_order_preserving_permutations(tested_hea, true, permutation_candidates);
#endif
					
					select_plan_preserving_permutations_old(tested_hea, permutation_candidates);

					// LOG list of order preserving permutations to cerr

					cerr << "Order preserving permutation candidates:" << endl;
					cerr << "----------------------------------------" << endl;
					for (vector<hea::Permutation>::const_iterator it_perm = permutation_candidates.begin(); it_perm != permutation_candidates.end(); ++it_perm) {
						for (int i = 0; i < it_perm->n; i++)
							cerr << it_perm->permutation[i]<< " ";
						cerr << endl;
					}
					cerr << "----------------------------------------" << endl;
//					return 0;

				}
				else {

					bool is_iso = false;
					for (vector<hea::Hea>::const_iterator it_vec = non_iso_list.begin(); it_vec != non_iso_list.end(); ++it_vec) {
						if (hea::are_isomorphic_perm_list(*it_vec, tested_hea, setCandidates, permutation_candidates)) {
							is_iso = true;
							break;
						}
					}

					if (!is_iso) {
						disp_hea(tested_hea);
						try {
							non_iso_list.push_back(tested_hea);
						}
						catch (std::bad_alloc &ba) {
							cerr << "Memory allocation error by inserting element:" << endl;
							hea::disp_hea(cerr, tested_hea);
							non_iso_list.clear();
							ifs.close();
							return 0;
						}
					}
				}

				// skip one line containing -M-
				char buffer[1024];
				ifs.getline(buffer, 1024);
			}
				
		}
		else {
			cerr << "Cannot open or read from file '" << argv[idx] << "'." << endl;
		}
		ifs.close();

		idx++;
	}

	return 0;
}


